Option Strict Off
Option Explicit On
Module Wrapper
	'*****************************************************************************
	'* Axcpl01w.vb
	'*
	'* AXC-PL01
	'*
	'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
	'*
	'* Date Aug.2004
	'*
	'*****************************************************************************
	
	Declare Function LoadLibrary Lib "Coredll.dll"  Alias "LoadLibraryW"(ByVal lpLibFileName As String) As Integer
	Declare Function FreeLibrary Lib "Coredll.dll" (ByVal hLibModule As Integer) As Integer
	Declare Function GetProcAddress Lib "Coredll.dll"  Alias "GetProcAddressW"(ByVal hModule As Integer, ByVal lpProcName As String) As Integer
	
	Dim hDLL As Integer ' DLLւ̃nh
    Public Const AXCPL01_DLL_NAME As String = "Axcpl01w.dll" ' DLL
    Public Const AXCPL01_ERR_WRAPDLL As Integer = -1   ' bp[֐G[

    '*****************************************************************************
    '*    Axcpl01.dll[h
    '*    
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Axcpl01wDllOpen() As Boolean
        Dim s As String

        s = "Axcpl01w.dll" & vbNullChar

        Axcpl01wDllOpen = False
        If hDLL <> 0 Then Exit Function
        hDLL = LoadLibrary(s)
        If hDLL = 0 Then Exit Function
        If Axcpl01wGetDllExportFunc() = False Then
            MsgBox("ExportFunc ERR")
            Axcpl01wDllClose() ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
            Exit Function
        End If
        Axcpl01wDllOpen = True
    End Function

    '*****************************************************************************
    '*    Axcpl01.dllA[h
    '*    
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Axcpl01wDllClose() As Boolean
        Axcpl01wDllClose = True
        If hDLL = 0 Then Exit Function
        If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Axcpl01wDllClose = False
    End Function

    '*****************************************************************************
    '*    AXC-PL01 DLL,Driver̃o[Wԍ擾
    '*    pdwDllVer  DLLo[Wԍi[
    '*        pdwDrvVer  Drivero[Wԍi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Axcpl01wGetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
        Axcpl01wGetVersion = False
        If hDLL = 0 Then Exit Function
        If Axcpl01GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
        Axcpl01wGetVersion = True
    End Function

    '*****************************************************************************
    '*    AXC-PL01̔Cӂ̃foCX̎gp錾
    '*    pwLogSocket gpfoCXi[AhX
    '*        hWnd        bZ[W𑗂EBhEnh
    '*        uWMBase     ƂȂ郁bZ[WID
    '*        pvInitArg   gp(0Zbg)
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Axcpl01wCreate(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Integer, ByRef pvInitArg As Integer) As Boolean
        Axcpl01wCreate = False
        If hDLL = 0 Then Exit Function
        If Axcpl01Create(pwLogSocket, hWnd, uWMBase, pvInitArg) = 0 Then Exit Function
        Axcpl01wCreate = True
    End Function

    '*****************************************************************************
    '*    AXC-PL01̔Cӂ̃foCX̎gpJ
    '*    wLogSocket gpfoCX
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Public Function Axcpl01wClose(ByVal wLogSocket As Short) As Boolean
        Axcpl01wClose = False
        If hDLL = 0 Then Exit Function
        If Axcpl01Close(wLogSocket) = 0 Then Exit Function
        Axcpl01wClose = True
    End Function

    '*****************************************************************************
    '*    wfoCX̃\[X擾
    '*    wLogSocket @@@ 擾foCX
    '*        pdwIOPortBase    I/Ox[XAhXi[
    '*        pdwIOPortLength  I/Ox[Xi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wGetResource(ByVal wLogSocket As Short, ByRef pdwIOPortBase As Integer, ByRef pdwIOPortLength As Integer) As Boolean
        Axcpl01wGetResource = False
        If hDLL = 0 Then Exit Function
        If Axcpl01GetResource(wLogSocket, pdwIOPortBase, pdwIOPortLength) = 0 Then Exit Function
        Axcpl01wGetResource = True
    End Function

    '*****************************************************************************
    '*    oCg
    '*    wLogSocket  擾foCX
    '*        dwPort      ̓|[gԍ
    '*        bpValue     ͒li[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wInPortB(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByRef pbValue As Byte) As Boolean
        Axcpl01wInPortB = False
        If hDLL = 0 Then Exit Function
        If Axcpl01InPortB(wLogSocket, dwPort, pbValue) = 0 Then Exit Function
        Axcpl01wInPortB = True
    End Function

    '*****************************************************************************
    '*    oCgo
    '*    wLogSocket  擾foCX
    '*        dwPort      o̓|[gԍ
    '*        bValue      o͂l
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wOutPortB(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByVal bValue As Byte) As Boolean
        Axcpl01wOutPortB = False
        If hDLL = 0 Then Exit Function
        If Axcpl01OutPortB(wLogSocket, dwPort, bValue) = 0 Then Exit Function
        Axcpl01wOutPortB = True
    End Function

    '*****************************************************************************
    '*    [h
    '*    wLogSocket  擾foCX
    '*        dwPort      ̓|[gԍ
    '*        pwValue     ͒li[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wInPortW(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByRef pwValue As Short) As Boolean
        Axcpl01wInPortW = False
        If hDLL = 0 Then Exit Function
        If Axcpl01InPortW(wLogSocket, dwPort, pwValue) = 0 Then Exit Function
        Axcpl01wInPortW = True
    End Function

    '*****************************************************************************
    '*    [ho
    '*    wLogSocket  擾foCX
    '*        dwPort      o̓|[gԍ
    '*        wValue      o͂l
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wOutPortW(ByVal wLogSocket As Short, ByVal dwPort As Integer, ByVal wValue As Short) As Boolean
        Axcpl01wOutPortW = False
        If hDLL = 0 Then Exit Function
        If Axcpl01OutPortW(wLogSocket, dwPort, wValue) = 0 Then Exit Function
        Axcpl01wOutPortW = True
    End Function

    '*****************************************************************************
    '*    wfoCX̊荞݃Xe[^X擾
    '*    wLogSocket   擾foCX
    '*        pbStatus     荞݃Xe[^Xi[
    '* ߂l  True
    '*        s False
    '*****************************************************************************
    Function Axcpl01wGetIRQStatus(ByVal wLogSocket As Short, ByRef pbStatus As Byte) As Boolean
        Axcpl01wGetIRQStatus = False
        If hDLL = 0 Then Exit Function
        If Axcpl01GetIRQStatus(wLogSocket, pbStatus) = 0 Then Exit Function
        Axcpl01wGetIRQStatus = True
    End Function


    '*****************************************************************************
    '*    AXC-PL01̃G[R[h
    '*    wLogSocket  G[foCX
    '* ߂l G[R[h
    '*****************************************************************************
    Function Axcpl01wGetLastError(ByVal wLogSocket As Short) As Integer
        Axcpl01wGetLastError = AXCPL01_ERR_WRAPDLL
        If hDLL = 0 Then Exit Function
        Axcpl01wGetLastError = Axcpl01GetLastError(wLogSocket)
    End Function

    '*---------------------------------------------------------------------------*
    '*    DLLGNX|[g֐L̊mF
    '*    
    '* ߂l  True
    '*        s False
    '*---------------------------------------------------------------------------*
    Private Function Axcpl01wGetDllExportFunc() As Boolean
        Dim pFunc As Integer

        Axcpl01wGetDllExportFunc = False

        ' Axcpl01GetVersion ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01GetVersion")
        If pFunc = 0 Then Exit Function

        ' Axcpl01Create ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01Create")
        If pFunc = 0 Then Exit Function

        ' Axcpl01Close ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01Close")
        If pFunc = 0 Then Exit Function

        ' Axcpl01GetResource ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01GetResource")
        If pFunc = 0 Then Exit Function

        ' Axcpl01InPortB ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01InPortB")
        If pFunc = 0 Then Exit Function

        ' Axcpl01OutPortB ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01OutPortB")
        If pFunc = 0 Then Exit Function

        ' Axcpl01InPortW ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01InPortW")
        If pFunc = 0 Then Exit Function

        ' Axcpl01OutPortW ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01OutPortW")
        If pFunc = 0 Then Exit Function

        ' Axcpl01GetIRQStatus ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01GetIRQStatus")
        If pFunc = 0 Then Exit Function

        ' Axcpl01GetLastError ̃AhX擾
        pFunc = GetProcAddress(hDLL, "Axcpl01GetLastError")

        If pFunc = 0 Then Exit Function

        Axcpl01wGetDllExportFunc = True ' SĂ DLL GNX|[g֐݂̑mF

    End Function
End Module