/*****************************************************************************
 * Axcpl01d.h
 *
 * AXC-PL01 API
 * Copyright(C)ADTEK SYSTEM SCIENCE Co.,Ltd
 *
 * Date Jan.2005
*****************************************************************************/

#ifndef _AxcPl01_H_
#define _AxcPl01_H_

#ifdef __cplusplus
extern "C" {
#endif

/*-----------------------------------------------------------------
// G[R[h
//---------------------------------------------------------------*/
#define AXCPL01_SUCCESS					0	/* ُȂiIj*/
#define AXCPL01_ERR_SYSTEM				1	/* Windows  GetLastError() R[Ă */
#define AXCPL01_ERR_NO_DEVICE			2	/* gp\ȃfoCX܂ */
#define AXCPL01_ERR_IN_USE				3	/* w̃foCX͎gpł */
#define AXCPL01_ERR_INVALID_SOCKET		4	/* Ș_\Pbgł */
#define AXCPL01_ERR_RESOURCE			5	/* \[XG[ */
#define AXCPL01_ERR_INVALID_PORT		6	/* sȃ|[gv */
#define AXCPL01_ERR_INVALID_ARGUMENT	7	/* sȈv܂ */

/*-----------------------------------------------------------------
// ̑̒萔
//---------------------------------------------------------------*/
#define AXCPL01_MAX_SOCKETS				16
#define AXCPL01_SOCKET_AUTO				((WORD)~0U)

/*-----------------------------------------------------------------
// hCo瑗Ă郁bZ[W
// ̒l uWMBase𑫂lĂ܂
//---------------------------------------------------------------*/
#define AXCPL01_WM_OFS_CARD_REMOVAL		0	/* J[hbZ[W */
#define AXCPL01_WM_OFS_IN				1	/* O͊荞݃bZ[W */

/*-----------------------------------------------------------------
// \[X\̊evf̍ő吔
//---------------------------------------------------------------*/
#define AXCPL01_MAX_MEM					9
#define AXCPL01_MAX_IO					20
#define AXCPL01_MAX_IRQ					7
#define AXCPL01_MAX_DMA					7
/*-----------------------------------------------------------------
// |[gAhX`
//---------------------------------------------------------------*/
#define AXCPL01_PORT_BASE				0x00	/* I/Ox[XAhX */
#define AXCPL01_PORT_BASE_PLUS1			0x01	/* I/Ox[XAhX{1 */
#define AXCPL01_PORT_BASE_PLUS2			0x02	/* I/Ox[XAhX{2 */
#define AXCPL01_PORT_BASE_PLUS3			0x03	/* I/Ox[XAhX{3 */
#define AXCPL01_PORT_BASE_PLUS4			0x04	/* I/Ox[XAhX{4 */
#define AXCPL01_PORT_BASE_PLUS5			0x05	/* I/Ox[XAhX{5 */
#define AXCPL01_PORT_BASE_PLUS6			0x06	/* I/Ox[XAhX{6 */
#define AXCPL01_PORT_BASE_PLUS7			0x07	/* I/Ox[XAhX{7 */
#define AXCPL01_PORT_BASE_PLUS8			0x08	/* I/Ox[XAhX{8 */
#define AXCPL01_PORT_BASE_PLUS9			0x09	/* I/Ox[XAhX{9 */
/*-----------------------------------------------------------------
// API Functions
//---------------------------------------------------------------*/
#define AXCPL01_API		extern __declspec( dllimport )

AXCPL01_API BOOL WINAPI Axcpl01GetVersion(PDWORD pdwDllVersion, PDWORD pdwDrvVersion);
AXCPL01_API BOOL WINAPI Axcpl01Create(PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg);
AXCPL01_API BOOL WINAPI Axcpl01Close(WORD wLogSocket);
AXCPL01_API BOOL WINAPI Axcpl01GetResource(WORD wLogSocket, PDWORD pdwIOPortBase, PDWORD pdwIOPortLength);
AXCPL01_API BOOL WINAPI Axcpl01InPortB(WORD wLogSocket, DWORD dwPort, PBYTE pbValue);
AXCPL01_API BOOL WINAPI Axcpl01OutPortB(WORD wLogSocket, DWORD dwPort, BYTE bValue);
AXCPL01_API BOOL WINAPI Axcpl01InPortW(WORD wLogSocket, DWORD dwPort, PWORD pwValue);
AXCPL01_API BOOL WINAPI Axcpl01OutPortW(WORD wLogSocket, DWORD dwPort, WORD wValue);
AXCPL01_API BOOL WINAPI Axcpl01GetIRQStatus(WORD wLogSocket, PBYTE pbStatus);
AXCPL01_API DWORD WINAPI Axcpl01GetLastError(WORD wLogSocket);

#ifdef __cplusplus
}
#endif
#endif
