/*****************************************************************************
 * Axcpl01w.c
 *
 * AXC-PL01
 * Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 * Date Jan.2005
/*****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "axcpl01w.h"
//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Axcpl01wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAxcpl01GetVersion;
static FARPROC pAxcpl01Create;
static FARPROC pAxcpl01Close;
static FARPROC pAxcpl01GetResource;
static FARPROC pAxcpl01InPortB;
static FARPROC pAxcpl01OutPortB;
static FARPROC pAxcpl01InPortW;
static FARPROC pAxcpl01OutPortW;
static FARPROC pAxcpl01GetIRQStatus;
static FARPROC pAxcpl01GetLastError;

BOOL Axcpl01wDllOpen ( void )
/*****************************************************************************
 * @\  axcpl01w.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AXCPL01_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Axcpl01wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Axcpl01wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Axcpl01wDllClose ( void )
/*****************************************************************************
 * @\  axcpl01w.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Axcpl01wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  AXC-PL01DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Axcpl01wCreate ( PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg )
/*****************************************************************************
 * @\  AXC-PL01̔Cӂ̃foCX̎gp錾
 * 	 pwLogSocket	--- gpfoCXi[AhX
 *		 hWnd		--- bZ[W󂯂EChEnh
 *		 uWMBase	--- bZ[Whc̃x[X
 *		 pvInitArg	--- \
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01Create)(pwLogSocket, hWnd, uWMBase, pvInitArg);
}

BOOL Axcpl01wClose ( WORD wLogSocket )
/*****************************************************************************
 * @\  AXC-PL01̔Cӂ̃foCX̎gpJ
 * 	 wLogSocket  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01Close)(wLogSocket);
}

BOOL Axcpl01wGetResource ( WORD wLogSocket, PDWORD pdwIOPortBase, PDWORD pdwIOPortLength )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSocket      --- ׂfoCX
 *		 pdwIOPortBase   --- I/Ox[XAhXi[\̂̃AhX
 *		 pdwIOPortLength --- I/OAhXi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01GetResource)(wLogSocket, pdwIOPortBase, pdwIOPortLength);
}

BOOL Axcpl01wInPortB (WORD wLogSocket, DWORD dwPort, PBYTE pbValue )
/*****************************************************************************
 * @\  e|[gɑ΂PoCg
 * 	 wLogSocket --- foCX
 *		 pbValue	--- 擾li[̈̃|C^
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01InPortB)(wLogSocket,dwPort,pbValue);
}

BOOL Axcpl01wOutPortB (WORD wLogSocket, DWORD dwPort, BYTE bValue )
/*****************************************************************************
 * @\  e|[gɑ΂oCgo
 * 	 wLogSocket --- foCX
 *		 bValue 	--- o͂l
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01OutPortB)(wLogSocket,dwPort,bValue);
}

BOOL Axcpl01wInPortW (WORD wLogSocket, DWORD dwPort, PWORD pwValue )
/*****************************************************************************
 * @\  e|[gɑ΂P[h
 * 	 wLogSocket --- foCX
 *		 pwValue	--- 擾li[̈̃|C^
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01InPortW)(wLogSocket,dwPort,pwValue);
}

BOOL Axcpl01wOutPortW (WORD wLogSocket, DWORD dwPort, WORD wValue )
/*****************************************************************************
 * @\  e|[gɑ΂[ho
 * 	 wLogSocket --- foCX
 *		 wValue 	--- o͂l
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if(hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01OutPortW)(wLogSocket,dwPort,wValue);
}

BOOL Axcpl01wGetIRQStatus ( WORD wLogSocket, PBYTE pbStatus )
/*****************************************************************************
 * @\  wfoCX̊荞݃Xe[^X擾
 * 	 wLogSocket   --- ׂfoCX
 *		 pbStatus     --- 荞݃Xe[^Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAxcpl01GetIRQStatus)(wLogSocket, pbStatus);
}


DWORD Axcpl01wGetLastError( WORD wLogSocket )
/*****************************************************************************
 * @\  G[R[h擾
 * 	 wLogSocket --- ΏۃfoCX
 * ߒl	 G[R[h
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AXCPL01_ERR_WRAPDLL;
	}
	return (*pAxcpl01GetLastError)(wLogSocket);
}

static BOOL Axcpl01wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Axcpl01GetVersion ̃AhX擾
	pAxcpl01GetVersion = GetProcAddress(hDLL, _T("Axcpl01GetVersion"));
	if (pAxcpl01GetVersion == NULL) return FALSE;

	// Axcpl01Create ̃AhX擾
	pAxcpl01Create = GetProcAddress(hDLL, _T("Axcpl01Create"));
	if (pAxcpl01Create == NULL) return FALSE;

	// Axcpl01Close ̃AhX擾
	pAxcpl01Close = GetProcAddress(hDLL, _T("Axcpl01Close"));
	if (pAxcpl01Close == NULL) return FALSE;

	// Axcpl01GetResource ̃AhX擾
	pAxcpl01GetResource = GetProcAddress(hDLL, _T("Axcpl01GetResource"));
	if ( pAxcpl01GetResource == NULL ) return FALSE;

	// Axcpl01InPortB ̃AhX擾
	pAxcpl01InPortB = GetProcAddress(hDLL, _T("Axcpl01InPortB"));
	if ( pAxcpl01InPortB == NULL ) return FALSE;

	// Axcpl01OutPortB ̃AhX擾
	pAxcpl01OutPortB = GetProcAddress(hDLL, _T("Axcpl01OutPortB"));
	if ( pAxcpl01OutPortB == NULL ) return FALSE;

	// Axcpl01InPortW ̃AhX擾
	pAxcpl01InPortW = GetProcAddress(hDLL, _T("Axcpl01InPortW"));
	if ( pAxcpl01InPortW == NULL ) return FALSE;

	// Axcpl01OutPortW ̃AhX擾
	pAxcpl01OutPortW = GetProcAddress(hDLL, _T("Axcpl01OutPortW"));
	if ( pAxcpl01OutPortW == NULL ) return FALSE;

	// Axcpl01GetIRQStatus ̃AhX擾
	pAxcpl01GetIRQStatus = GetProcAddress(hDLL, _T("Axcpl01GetIRQStatus"));
	if ( pAxcpl01GetResource == NULL ) return FALSE;

	// Axcpl01GetLastError ̃AhX擾
	pAxcpl01GetLastError = GetProcAddress(hDLL, _T("Axcpl01GetLastError"));
	if ( pAxcpl01GetLastError == NULL ) {
		return FALSE;
	}

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
